#include "jbsql.h"

void Describe(TextWidget *text,char *command)
{
  char *str,*owner,*object,*object_type;
  char query[4000];
  int x;
  ExecuteStruct *es;
  
  if (!ora_connected)
  {
    WPrintf("Not connected to a database\n");
    ClearCommand(text,1,0);
    return;
  }
  object=strchr(command,' ');
  if (object==NULL)
  {
    WPrintf("Usage: desc[ribe] [owner.]object\n");
    return;
  }
  str=strdup(object);
  Trim(str);
  for (x=0;x<(int)strlen(str);x++)
    str[x]=toupper(str[x]);
  object=strchr(str,'.');
  if (object==NULL)
  {
    GetUserID(str,&owner,&object,1);
  }
  else
  {
    *object='\0';
    owner=strdup(str);
    object++;
    object=strdup(object);
  }
  free(str);
  if (owner!=NULL)
  {
    object_type=GetOracleObjectType(owner,object,1);
    if (object_type!=NULL)
    {
      if (!strcmp(object_type,"TABLE") || !strcmp(object_type,"VIEW"))
      {
        sprintf(query,"select t.column_name,t.data_type,t.data_length,t.data_precision,t.data_scale,t.nullable,c.comments from all_tab_columns t,all_col_comments c where t.table_name='%s' and t.owner='%s' and c.owner(+)=t.owner and c.table_name(+)=t.table_name and c.column_name(+)=t.column_name order by column_id",object,owner);
        es=malloc(sizeof(ExecuteStruct));
        es->text=text;
        es->data=strdup(query);
        strcpy(es->action,"");
        ExecuteQuery(es);
      }
      else if (!strcmp(object_type,"PACKAGE"))
      {
        sprintf(query,"select decode(overload,null,object_name,object_name||' ('||to_char(overload)||')')||decode(position,0,' (FUNCTION)','') procedure,nvl(argument_name,decode(in_out,'OUT','<return value>','<none>')) argument,in_out,decode(type_subname,null,decode(data_type,'VARCHAR2',decode(data_length,null,data_type,data_type||' ('||data_length||')'),data_type),data_type||' ('||type_subname||')') datatype from all_arguments where owner='%s' and package_name='%s' order by object_name,overload,position",owner,object);
        es=malloc(sizeof(ExecuteStruct));
        es->text=text;
        es->data=strdup(query);
        strcpy(es->action,"");
        ExecuteQuery(es);
      }
      else if (!strcmp(object_type,"FUNCTION") || !strcmp(object_type,"PROCEDURE"))
      {
        sprintf(query,"select nvl(argument_name,decode(in_out,'OUT','<return value>','<none>')) argument,in_out,decode(type_subname,null,decode(data_type,'VARCHAR2',decode(data_length,null,data_type,data_type||' ('||data_length||')'),data_type),data_type||' ('||type_subname||')') datatype from all_arguments where owner='%s' and object_name='%s' order by object_name,overload,position",owner,object);
        es=malloc(sizeof(ExecuteStruct));
        es->text=text;
        es->data=strdup(query);
        strcpy(es->action,"");
        ExecuteQuery(es);
      }
      else
      {
        WPrintf("Feature not implemented yet: %s\n",object_type);
        ClearCommand(text,1,0);
      }
    }
    else
    {
      ClearCommand(text,1,0);
    }
  }
  else
  {
    ClearCommand(text,1,0);
  }
  free(object);
  free(owner);
}
