#include "jbsql.h"

#define FAVOURITES_CLASS_NAME "FavouritesClass"
HFONT fv_f,fv_f2;

void CreateFavourites(HWND parent)
{
  HWND hWnd;
  HDC hDC;

  hDC=GetDC(parent);
  fv_f=CreateFont(-MulDiv(8, GetDeviceCaps(hDC, LOGPIXELSY), 72), // logical height of font
               0,                     // logical average character width
               0,                     // angle of escapement
               0,                     // base-line orientation angle
               FW_NORMAL,             // font weight
               FALSE,                 // italic attribute flag
               FALSE,                 // underline attribute flag
               FALSE,                 // strikeout attribute flag
               DEFAULT_CHARSET,       // character set identifier
               OUT_DEFAULT_PRECIS,    // output precision
               CLIP_DEFAULT_PRECIS,   // clipping precision
               DEFAULT_QUALITY,       // output quality
               FF_SWISS,              // pitch and family
               "MS Sans Serif"          // pointer to typeface name string
               );
  fv_f2=CreateFont(-MulDiv(10, GetDeviceCaps(hDC, LOGPIXELSY), 72), // logical height of font
               0,                     // logical average character width
               0,                     // angle of escapement
               0,                     // base-line orientation angle
               FW_NORMAL,             // font weight
               FALSE,                 // italic attribute flag
               FALSE,                 // underline attribute flag
               FALSE,                 // strikeout attribute flag
               DEFAULT_CHARSET,       // character set identifier
               OUT_DEFAULT_PRECIS,    // output precision
               CLIP_DEFAULT_PRECIS,   // clipping precision
               DEFAULT_QUALITY,       // output quality
               FF_MODERN,             // pitch and family
               "Courier New"          // pointer to typeface name string
               );


  ReleaseDC(parent,hDC);

  hWnd = CreateWindowEx( 0,          // ex style
												 "STATIC",    // class name - defined in commctrl.h
												 "Favourites",                        // dummy text
												 WS_CHILD|WS_VISIBLE|SS_SIMPLE,       // style
												 10,                        // x position
												 10,                        // y position
												 100,                        // width
												 17,                        // height
												 parent,                    // parent
												 (HMENU)ID_FAVOURITES_TEXT,   // ID
												 g_hInst,                   // instance
												 NULL);                     // no extra data
	if(!hWnd)
  {
    DisplayLastError(NULL);
	  return;
  }
  SendMessage(hWnd,WM_SETFONT,(WPARAM)fv_f,(LPARAM)TRUE);

  hWnd = CreateWindowEx( 0,          // ex style
												 WC_TREEVIEW,    // class name - defined in commctrl.h
												 "",                        // dummy text
												 WS_CHILD|WS_VISIBLE|WS_TABSTOP|WS_HSCROLL|WS_VSCROLL|TVS_HASLINES|TVS_LINESATROOT|WS_BORDER,       // style
												 10,                        // x position
												 30,                        // y position
												 300,                        // width
												 200,                        // height
												 parent,                    // parent
												 (HMENU)ID_FAVOURITES_TREE,   // ID
												 g_hInst,                   // instance
												 NULL);                     // no extra data
	if(!hWnd)
  {
    DisplayLastError(NULL);
	  return;
  }
  SendMessage(hWnd,WM_SETFONT,(WPARAM)fv_f,(LPARAM)TRUE);

  hWnd = CreateWindowEx( 0,          // ex style
												 "BUTTON",    // class name - defined in commctrl.h
												 "Paste",                        // dummy text
												 WS_CHILD|WS_VISIBLE|WS_TABSTOP,       // style
												 320,                        // x position
												 30,                        // y position
												 80,                        // width
												 20,                        // height
												 parent,                    // parent
												 (HMENU)ID_FAVOURITES_PASTE,   // ID
												 g_hInst,                   // instance
												 NULL);                     // no extra data
	if(!hWnd)
  {
    DisplayLastError(NULL);
	  return;
  }
  SendMessage(hWnd,WM_SETFONT,(WPARAM)fv_f,(LPARAM)TRUE);

  hWnd = CreateWindowEx( 0,          // ex style
												 "BUTTON",    // class name - defined in commctrl.h
												 "Cut",                        // dummy text
												 WS_CHILD|WS_VISIBLE|WS_TABSTOP,       // style
												 320,                        // x position
												 55,                        // y position
												 80,                        // width
												 20,                        // height
												 parent,                    // parent
												 (HMENU)ID_FAVOURITES_CUT,   // ID
												 g_hInst,                   // instance
												 NULL);                     // no extra data
	if(!hWnd)
  {
    DisplayLastError(NULL);
	  return;
  }
  SendMessage(hWnd,WM_SETFONT,(WPARAM)fv_f,(LPARAM)TRUE);

  hWnd = CreateWindowEx( 0,          // ex style
												 "BUTTON",    // class name - defined in commctrl.h
												 "New folder",                        // dummy text
												 WS_CHILD|WS_VISIBLE|WS_TABSTOP,       // style
												 320,                        // x position
												 80,                        // y position
												 80,                        // width
												 20,                        // height
												 parent,                    // parent
												 (HMENU)ID_FAVOURITES_NEWFOLDER,   // ID
												 g_hInst,                   // instance
												 NULL);                     // no extra data
	if(!hWnd)
  {
    DisplayLastError(NULL);
	  return;
  }
  SendMessage(hWnd,WM_SETFONT,(WPARAM)fv_f,(LPARAM)TRUE);

  hWnd = CreateWindowEx( 0,          // ex style
												 "BUTTON",    // class name - defined in commctrl.h
												 "Close",                        // dummy text
												 WS_CHILD|WS_VISIBLE|WS_TABSTOP,       // style
												 320,                        // x position
												 105,                        // y position
												 80,                        // width
												 20,                        // height
												 parent,                    // parent
												 (HMENU)ID_FAVOURITES_CLOSE,   // ID
												 g_hInst,                   // instance
												 NULL);                     // no extra data
	if(!hWnd)
  {
    DisplayLastError(NULL);
	  return;
  }
  SendMessage(hWnd,WM_SETFONT,(WPARAM)fv_f,(LPARAM)TRUE);

}

void ResizeFavourites(HWND parent)
{
  RECT rc;
  HWND hWnd;
  int width,height=17;
  
  GetClientRect(parent,&rc);  
  width=(rc.right-rc.left-10)/3-10;
}

LRESULT CALLBACK FavouritesWndProc(HWND hWnd,
                                   UINT uMessage,
                                   WPARAM wParam,
                                   LPARAM lParam)
{
	switch (uMessage)
	{
		case WM_CREATE:
      CreateFavourites(hWnd);
			return 0;

		case WM_SIZE:
  		ResizeFavourites(hWnd);
			return 1;
			break;

		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
      }
			break;

		case WM_DESTROY:
			break;

    case WM_CLOSE:
      DeleteObject(fv_f);
      DeleteObject(fv_f2);
      DestroyWindow(hWnd);
      break;

		default:
			break;
  }
	return DefWindowProc(hWnd, uMessage, wParam, lParam);
}

HWND ShowFavourites(HWND parent)
{
  HWND        hWnd;
	DWORD       dwStyle;
	BOOL        bSuccess = TRUE;
	WNDCLASSEX  wcex;
	ATOM        aReturn;
  static int  created=0;

  if (tid)
    return NULL;
  if (!created)
  {
	  wcex.cbSize          = sizeof(WNDCLASSEX);
	  wcex.style           = 0;
	  wcex.lpfnWndProc     = (WNDPROC)FavouritesWndProc;
	  wcex.cbClsExtra      = 0;
	  wcex.cbWndExtra      = 0;
	  wcex.hInstance       = g_hInst;
	  wcex.hCursor         = LoadCursor(NULL, IDC_ARROW);
	  wcex.hbrBackground   = GetSysColorBrush(COLOR_3DFACE);
	  wcex.lpszMenuName    = NULL;
	  wcex.lpszClassName   = FAVOURITES_CLASS_NAME;
	  wcex.hIcon           = LoadIcon(g_hInst, MAKEINTRESOURCE(IDI_JBSQL));
	  wcex.hIconSm         = LoadImage(g_hInst, MAKEINTRESOURCE(IDI_JBSQL), IMAGE_ICON, 16, 16, 0);

	  aReturn = RegisterClassEx(&wcex);
    if (aReturn==0)
      DisplayLastError(NULL);
    created=1;
  }

	dwStyle =   WS_POPUPWINDOW|WS_VISIBLE|WS_OVERLAPPEDWINDOW|WS_SIZEBOX;
	
	hWnd = CreateWindowEx( WS_EX_APPWINDOW|WS_EX_CONTROLPARENT|WS_EX_OVERLAPPEDWINDOW,          // ex style
												 FAVOURITES_CLASS_NAME, // class name - defined in commctrl.h
												 "Favourites",          // dummy text
												 dwStyle,                   // style
												 0,                         // x position
												 0,                         // y position
												 500,                       // width
												 500,                       // height
												 parent,                    // parent
												 NULL,                      // ID
												 g_hInst,                   // instance
												 NULL);                     // no extra data
	if(!hWnd)
  {
    DisplayLastError(NULL);
	  return NULL;
  }
  ShowWindow(hWnd,SW_SHOW);

  return hWnd;
}
