#include "jboci.h"

int ProcessColumns(HWND hWnd,char *schema,char *table)
{
  OCIBind *bndhp=NULL;
  OCIDefine *defhp=NULL;
  OCIStmt *stmtp=NULL;
  char *columnstr="select column_name,data_type,data_type_mod,data_type_owner,data_length,data_precision,data_scale,nullable,default_length,data_default from all_tab_columns where owner=:p_schema and table_name=:p_table order by column_id";
  char column_name[31]="",data_type[107]="",data_type_mod[4]="",data_type_owner[31]="",nullable[2]="",data_default[32000]="";
  unsigned data_length,data_precision,data_scale,default_length;
  ub2 column_name_i,data_type_i,data_type_mod_i,data_type_owner_i,nullable_i,data_default_i;
  ub2 data_length_i,data_precision_i,data_scale_i,default_length_i;
  int n,result;

  if (ChkOCIErrS(OCIHandleAlloc(g_oci->envhp, 
                               (dvoid**)&stmtp,
                               OCI_HTYPE_STMT, 
                               0, 
                               NULL)))
  {
    return -1;
  }
  if (ChkOCIErrS(OCIStmtPrepare(stmtp,
                               g_oci->errhp,
                               columnstr,
                               strlen(columnstr),
                               OCI_NTV_SYNTAX,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  if (ChkOCIErrS(OCIBindByName(stmtp,
                             &bndhp,
                             g_oci->errhp,
                             "p_schema",
                             strlen("p_schema"),
                             schema,
                             strlen(schema)+1,
                             SQLT_STR,
                             NULL,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -1;
  }
  if (ChkOCIErrS(OCIBindByName(stmtp,
                             &bndhp,
                             g_oci->errhp,
                             "p_table",
                             strlen("p_table"),
                             table,
                             strlen(table)+1,
                             SQLT_STR,
                             NULL,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -1;
  }
  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               1,
                               column_name,
                               sizeof(column_name),
                               SQLT_STR,
                               &column_name_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               2,
                               data_type,
                               sizeof(data_type),
                               SQLT_STR,
                               &data_type_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               3,
                               data_type_mod,
                               sizeof(data_type_mod),
                               SQLT_STR,
                               &data_type_mod_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               4,
                               &data_type_owner,
                               sizeof(data_type_owner),
                               SQLT_STR,
                               &data_type_owner_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               5,
                               &data_length,
                               sizeof(data_length),
                               SQLT_UIN,
                               &data_length_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               6,
                               &data_precision,
                               sizeof(data_precision),
                               SQLT_UIN,
                               &data_precision_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               7,
                               &data_scale,
                               sizeof(data_scale),
                               SQLT_UIN,
                               &data_scale_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               8,
                               &nullable,
                               sizeof(nullable),
                               SQLT_STR,
                               &nullable_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               9,
                               &default_length,
                               sizeof(default_length),
                               SQLT_UIN,
                               &default_length_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               10,
                               &data_default,
                               sizeof(data_default),
                               SQLT_STR,
                               &data_default_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIStmtExecute(g_oci->svchp,
                        stmtp,
                        g_oci->errhp,
                        0,
                        0,
                        NULL,
                        NULL,
                        OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  n=0;
  for (;;)
  {
    result=OCIStmtFetch(stmtp,
                        g_oci->errhp,
                        1,
                        OCI_FETCH_NEXT,
                        OCI_DEFAULT);
    if (result!=OCI_SUCCESS && result!=OCI_NO_DATA && result!=OCI_SUCCESS_WITH_INFO)
    {
      break;
    }
    if (result==OCI_NO_DATA)
      break;
    if (n)
      SchemaPrintf(hWnd," ,\"%s\" ",column_name);
    else
      SchemaPrintf(hWnd,"  \"%s\" ",column_name);
    if (data_type_owner_i!=(ub2)-1 && strcmp(data_type_owner,schema))
      SchemaPrintf(hWnd,"%s.",data_type_owner);
    SchemaPrintf(hWnd,"%s",data_type);
    if (!strcmp(data_type,"VARCHAR2") || 
        !strcmp(data_type,"NVARCHAR2") ||
        !strcmp(data_type,"RAW") || 
        !strcmp(data_type,"CHAR") ||
        !strcmp(data_type,"NCHAR"))
    {
      SchemaPrintf(hWnd,"(%u)",data_length);
    }
    if (!strcmp(data_type,"NUMBER"))
    {
      if (data_precision_i!=(ub2)-1)
      {
        SchemaPrintf(hWnd,"(%u",data_precision);
        if (data_scale_i!=(ub2)-1)
          SchemaPrintf(hWnd,",%u",data_scale);
        SchemaPrintf(hWnd,")");
      }
      else if (data_precision_i==(ub2)-1 && data_scale_i!=(ub2)-1)
        SchemaPrintf(hWnd,"(38)");
    }
    if (data_default_i!=(ub2)-1)
    {
      if (!strcmp(data_type,"VARCHAR2") || 
          !strcmp(data_type,"NVARCHAR2") ||
          !strcmp(data_type,"RAW") || 
          !strcmp(data_type,"CHAR") ||
          !strcmp(data_type,"NCHAR"))
        SchemaPrintf(hWnd," DEFAULT '%s'",data_default);
      else
        SchemaPrintf(hWnd," DEFAULT %s",data_default);
    }
    if (!strcmp(nullable,"N"))
      SchemaPrintf(hWnd," NOT NULL");
    SchemaPrintf(hWnd,"\n");
    n++;
  }
  OCIHandleFree(stmtp,OCI_HTYPE_STMT);
  stmtp=NULL;
  return 0;
}

int ProcessTable(HWND hWnd,char *schema,char *table)
{
  char *tablestr="select tablespace_name,cluster_name,iot_name,pct_free,pct_used,ini_trans,max_trans,initial_extent,next_extent,min_extents,max_extents,pct_increase,freelists,freelist_groups,iot_type from all_tables where owner=:p_schema and table_name=:p_table";
  char tablespace_name[31]="",cluster_name[31]="",iot_name[31]="",iot_type[13]="";
  unsigned int pct_free,pct_used,ini_trans,max_trans,initial_extent,next_extent,min_extents,max_extents,pct_increase,freelists,freelist_groups;
  ub2 tablespace_name_i=-1,cluster_name_i=-1,iot_name_i=-1,pct_free_i=-1,pct_used_i=-1,ini_trans_i=-1,max_trans_i=-1,initial_extent_i=-1,next_extent_i=-1,min_extents_i=-1,max_extents_i=-1,pct_increase_i=-1,freelists_i=-1,freelist_groups_i=-1,iot_type_i=-1;
  OCIBind *bndhp=NULL;
  OCIDefine *defhp=NULL;
  OCIStmt *stmtp=NULL;

  if (ChkOCIErrS(OCIHandleAlloc(g_oci->envhp, 
                               (dvoid**)&stmtp,
                               OCI_HTYPE_STMT, 
                               0, 
                               NULL)))
  {
    return -1;
  }
  if (ChkOCIErrS(OCIStmtPrepare(stmtp,
                               g_oci->errhp,
                               tablestr,
                               strlen(tablestr),
                               OCI_NTV_SYNTAX,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  if (ChkOCIErrS(OCIBindByName(stmtp,
                             &bndhp,
                             g_oci->errhp,
                             "p_schema",
                             strlen("p_schema"),
                             schema,
                             strlen(schema)+1,
                             SQLT_STR,
                             NULL,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -1;
  }
  if (ChkOCIErrS(OCIBindByName(stmtp,
                             &bndhp,
                             g_oci->errhp,
                             "p_table",
                             strlen("p_table"),
                             table,
                             strlen(table)+1,
                             SQLT_STR,
                             NULL,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -1;
  }
  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               1,
                               tablespace_name,
                               sizeof(tablespace_name),
                               SQLT_STR,
                               &tablespace_name_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               2,
                               cluster_name,
                               sizeof(cluster_name),
                               SQLT_STR,
                               &cluster_name_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               3,
                               iot_name,
                               sizeof(iot_name),
                               SQLT_STR,
                               &iot_name_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               4,
                               &pct_free,
                               sizeof(pct_free),
                               SQLT_UIN,
                               &pct_free_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               5,
                               &pct_used,
                               sizeof(pct_used),
                               SQLT_UIN,
                               &pct_used_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               6,
                               &ini_trans,
                               sizeof(ini_trans),
                               SQLT_UIN,
                               &ini_trans_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               7,
                               &max_trans,
                               sizeof(max_trans),
                               SQLT_UIN,
                               &max_trans_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               8,
                               &initial_extent,
                               sizeof(initial_extent),
                               SQLT_UIN,
                               &initial_extent_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               9,
                               &next_extent,
                               sizeof(next_extent),
                               SQLT_UIN,
                               &next_extent_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               10,
                               &min_extents,
                               sizeof(min_extents),
                               SQLT_UIN,
                               &min_extents_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               11,
                               &max_extents,
                               sizeof(max_extents),
                               SQLT_UIN,
                               &max_extents_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               12,
                               &pct_increase,
                               sizeof(pct_increase),
                               SQLT_UIN,
                               &pct_increase_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               13,
                               &freelists,
                               sizeof(freelists),
                               SQLT_UIN,
                               &freelists_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               14,
                               &freelist_groups,
                               sizeof(freelist_groups),
                               SQLT_UIN,
                               &freelist_groups_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIStmtExecute(g_oci->svchp,
                        stmtp,
                        g_oci->errhp,
                        0,
                        0,
                        NULL,
                        NULL,
                        OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  if (ChkOCIErrS(OCIStmtFetch(stmtp,
                      g_oci->errhp,
                      1,
                      OCI_FETCH_NEXT,
                      OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  OCIHandleFree(stmtp,OCI_HTYPE_STMT);
  stmtp=NULL;
  SchemaPrintf(hWnd,"CREATE TABLE \"%s\" (\n",table);
  /* Create columns */
  if (ProcessColumns(hWnd,schema,table)!=0)
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -1;
  }
  SchemaPrintf(hWnd,")\n");
  if (tablespace_name_i!=(ub2)-1)
    SchemaPrintf(hWnd,"TABLESPACE \"%s\"\n",tablespace_name);
  if (pct_free_i!=(ub2)-1)
    SchemaPrintf(hWnd,"PCTFREE %u\n",pct_free);
  if (iot_type_i==(ub2)-1 || strcmp(iot_type,"IOT")) /* Not an index-organized table */
  {
    if (pct_used_i!=(ub2)-1)
      SchemaPrintf(hWnd,"PCTUSED %u\n",pct_used);
  }
  if (ini_trans_i!=(ub2)-1)
    SchemaPrintf(hWnd,"INITRANS %u\n",ini_trans);
  if (max_trans_i!=(ub2)-1)
    SchemaPrintf(hWnd,"MAXTRANS %u\n",max_trans);
  if (initial_extent_i!=(ub2)-1 ||
      next_extent_i!=(ub2)-1 ||
      min_extents_i!=(ub2)-1 ||
      max_extents_i!=(ub2)-1 ||
      pct_increase_i!=(ub2)-1 ||
      freelists_i!=(ub2)-1 ||
      freelist_groups_i!=(ub2)-1)
  {     
    SchemaPrintf(hWnd,"STORAGE (\n");
    if (initial_extent_i!=(ub2)-1)
      SchemaPrintf(hWnd,"         INITIAL %u\n",initial_extent);
    if (next_extent_i!=(ub2)-1)
      SchemaPrintf(hWnd,"         NEXT %u\n",next_extent);
    if (min_extents_i!=(ub2)-1)
      SchemaPrintf(hWnd,"         MINEXTENTS %u\n",min_extents);
    if (max_extents_i!=(ub2)-1)
      SchemaPrintf(hWnd,"         MAXEXTENTS %u\n",max_extents);
    if (pct_increase_i!=(ub2)-1)
      SchemaPrintf(hWnd,"         PCTINCREASE %u\n",pct_increase);
    if (freelists_i!=(ub2)-1)
      SchemaPrintf(hWnd,"         FREELISTS %u\n",freelists);
    if (freelist_groups_i!=(ub2)-1)
      SchemaPrintf(hWnd,"         FREELIST GROUPS %u\n",freelist_groups);
    SchemaPrintf(hWnd,"        )\n");
  }
  SchemaPrintf(hWnd,"/\n\n");
  if (ProcessQuery(hWnd,"SELECT INDEX_NAME FROM ALL_INDEXES WHERE OWNER=:schema_name AND table_name=:object_name",schema,table,ProcessIndex)!=0)
    return -1;
  if (ProcessQuery(hWnd,"SELECT CONSTRAINT_NAME FROM ALL_CONSTRAINTS WHERE OWNER=:schema_name AND CONSTRAINT_TYPE='P' AND table_name=:object_name",schema,table,ProcessConstraint)!=0)
    return -1;
  if (ProcessQuery(hWnd,"SELECT CONSTRAINT_NAME FROM ALL_CONSTRAINTS WHERE OWNER=:schema_name AND CONSTRAINT_TYPE='U' AND table_name=:object_name",schema,table,ProcessConstraint)!=0)
    return -1;
  if (ProcessQuery(hWnd,"SELECT CONSTRAINT_NAME FROM ALL_CONSTRAINTS WHERE OWNER=:schema_name AND CONSTRAINT_TYPE='C' AND table_name=:object_name",schema,table,ProcessConstraint)!=0)
    return -1;
  if (ProcessQuery(hWnd,"SELECT CONSTRAINT_NAME FROM ALL_CONSTRAINTS WHERE OWNER=:schema_name AND CONSTRAINT_TYPE='R' AND table_name=:object_name",schema,table,ProcessConstraint)!=0)
    return -1;

  return 0;
}

