#include "jbsql.h"

#define SCHEMA_BROWSER_CLASS_NAME "SchemaBrowserClass"
HFONT sb_f,sb_f2;

void CreateSchemaBrowser(HWND parent)
{
  HWND hWnd;
  HDC hDC;

  hDC=GetDC(parent);
  sb_f=CreateFont(-MulDiv(8, GetDeviceCaps(hDC, LOGPIXELSY), 72), // logical height of font
               0,                     // logical average character width
               0,                     // angle of escapement
               0,                     // base-line orientation angle
               FW_NORMAL,             // font weight
               FALSE,                 // italic attribute flag
               FALSE,                 // underline attribute flag
               FALSE,                 // strikeout attribute flag
               DEFAULT_CHARSET,       // character set identifier
               OUT_DEFAULT_PRECIS,    // output precision
               CLIP_DEFAULT_PRECIS,   // clipping precision
               DEFAULT_QUALITY,       // output quality
               FF_SWISS,              // pitch and family
               "MS Sans Serif"          // pointer to typeface name string
               );
  sb_f2=CreateFont(-MulDiv(10, GetDeviceCaps(hDC, LOGPIXELSY), 72), // logical height of font
               0,                     // logical average character width
               0,                     // angle of escapement
               0,                     // base-line orientation angle
               FW_NORMAL,             // font weight
               FALSE,                 // italic attribute flag
               FALSE,                 // underline attribute flag
               FALSE,                 // strikeout attribute flag
               DEFAULT_CHARSET,       // character set identifier
               OUT_DEFAULT_PRECIS,    // output precision
               CLIP_DEFAULT_PRECIS,   // clipping precision
               DEFAULT_QUALITY,       // output quality
               FF_MODERN,             // pitch and family
               "Courier New"          // pointer to typeface name string
               );


  ReleaseDC(parent,hDC);

  hWnd = CreateWindowEx( 0,          // ex style
												 "STATIC",    // class name - defined in commctrl.h
												 "Schema",                        // dummy text
												 WS_CHILD|WS_VISIBLE|SS_SIMPLE,       // style
												 10,                        // x position
												 10,                        // y position
												 100,                        // width
												 17,                        // height
												 parent,                    // parent
												 (HMENU)ID_SCHEMABROWSER_SCHEMA_TEXT,   // ID
												 g_hInst,                   // instance
												 NULL);                     // no extra data
	if(!hWnd)
  {
    DisplayLastError(NULL);
	  return;
  }
  SendMessage(hWnd,WM_SETFONT,(WPARAM)sb_f,(LPARAM)TRUE);

  hWnd = CreateWindowEx( 0,          // ex style
												 "COMBOBOX",    // class name - defined in commctrl.h
												 "",                        // dummy text
												 WS_CHILD|WS_VISIBLE|WS_TABSTOP|WS_HSCROLL|WS_VSCROLL|CBS_DROPDOWNLIST|CBS_SORT,       // style
												 10,                        // x position
												 30,                        // y position
												 100,                        // width
												 300,                        // height
												 parent,                    // parent
												 (HMENU)ID_SCHEMABROWSER_SCHEMA,   // ID
												 g_hInst,                   // instance
												 NULL);                     // no extra data
	if(!hWnd)
  {
    DisplayLastError(NULL);
	  return;
  }
  SendMessage(hWnd,WM_SETFONT,(WPARAM)sb_f,(LPARAM)TRUE);

  hWnd = CreateWindowEx( 0,          // ex style
												 "STATIC",    // class name - defined in commctrl.h
												 "Object",                        // dummy text
												 WS_CHILD|WS_VISIBLE|SS_SIMPLE,       // style
												 120,                        // x position
												 10,                        // y position
												 100,                        // width
												 17,                        // height
												 parent,                    // parent
												 (HMENU)ID_SCHEMABROWSER_TYPE_TEXT,   // ID
												 g_hInst,                   // instance
												 NULL);                     // no extra data
	if(!hWnd)
  {
    DisplayLastError(NULL);
	  return;
  }
  SendMessage(hWnd,WM_SETFONT,(WPARAM)sb_f,(LPARAM)TRUE);

  hWnd = CreateWindowEx( 0,          // ex style
												 "COMBOBOX",    // class name - defined in commctrl.h
												 "",                        // dummy text
												 WS_CHILD|WS_VISIBLE|WS_TABSTOP|WS_HSCROLL|WS_VSCROLL|CBS_DROPDOWNLIST|CBS_SORT,       // style
												 120,                        // x position
												 30,                        // y position
												 100,                        // width
												 300,                        // height
												 parent,                    // parent
												 (HMENU)ID_SCHEMABROWSER_TYPE,   // ID
												 g_hInst,                   // instance
												 NULL);                     // no extra data
	if(!hWnd)
  {
    DisplayLastError(NULL);
	  return;
  }
  SendMessage(hWnd,WM_SETFONT,(WPARAM)sb_f,(LPARAM)TRUE);

  hWnd = CreateWindowEx( 0,          // ex style
												 "STATIC",    // class name - defined in commctrl.h
												 "Name",                        // dummy text
												 WS_CHILD|WS_VISIBLE|SS_SIMPLE,       // style
												 230,                        // x position
												 10,                        // y position
												 100,                        // width
												 17,                        // height
												 parent,                    // parent
												 (HMENU)ID_SCHEMABROWSER_NAME_TEXT,   // ID
												 g_hInst,                   // instance
												 NULL);                     // no extra data
	if(!hWnd)
  {
    DisplayLastError(NULL);
	  return;
  }
  SendMessage(hWnd,WM_SETFONT,(WPARAM)sb_f,(LPARAM)TRUE);

  hWnd = CreateWindowEx( 0,          // ex style
												 "COMBOBOX",    // class name - defined in commctrl.h
												 "",                        // dummy text
												 WS_CHILD|WS_VISIBLE|WS_TABSTOP|WS_HSCROLL|WS_VSCROLL|CBS_DROPDOWNLIST|CBS_SORT,       // style
												 230,                        // x position
												 30,                        // y position
												 100,                        // width
												 300,                        // height
												 parent,                    // parent
												 (HMENU)ID_SCHEMABROWSER_NAME,   // ID
												 g_hInst,                   // instance
												 NULL);                     // no extra data
	if(!hWnd)
  {
    DisplayLastError(NULL);
	  return;
  }
  SendMessage(hWnd,WM_SETFONT,(WPARAM)sb_f,(LPARAM)TRUE);


  hWnd = CreateWindowEx( WS_EX_CLIENTEDGE,          // ex style
												 "EDIT",    // class name - defined in commctrl.h
												 "",                        // dummy text
												 WS_CHILD|WS_VISIBLE|WS_TABSTOP|WS_HSCROLL|WS_VSCROLL|ES_AUTOHSCROLL|ES_AUTOVSCROLL|ES_MULTILINE|ES_WANTRETURN,       // style
												 10,                        // x position
												 60,                        // y position
												 440,                        // width
												 400,                        // height
												 parent,                    // parent
												 (HMENU)ID_SCHEMABROWSER_CODE,   // ID
												 g_hInst,                   // instance
												 NULL);                     // no extra data
	if(!hWnd)
  {
    DisplayLastError(NULL);
	  return;
  }
  SendMessage(hWnd,WM_SETFONT,(WPARAM)sb_f2,(LPARAM)TRUE);
  SendMessage(hWnd,EM_SETLIMITTEXT,(WPARAM)0,(LPARAM)0);
}

void ResizeSchemaBrowser(HWND parent)
{
  RECT rc;
  HWND hWnd;
  int width,height=17;
  
  GetClientRect(parent,&rc);  
  width=(rc.right-rc.left-10)/3-10;
  hWnd=GetDlgItem(parent,ID_SCHEMABROWSER_SCHEMA_TEXT);
  SetWindowPos(hWnd,0,10,10,width,height,SWP_NOOWNERZORDER);
  hWnd=GetDlgItem(parent,ID_SCHEMABROWSER_SCHEMA);
  SetWindowPos(hWnd,0,10,10+height,width,height,SWP_NOOWNERZORDER);

  hWnd=GetDlgItem(parent,ID_SCHEMABROWSER_TYPE_TEXT);
  SetWindowPos(hWnd,0,10+width+10,10,width,height,SWP_NOOWNERZORDER);
  hWnd=GetDlgItem(parent,ID_SCHEMABROWSER_TYPE);
  SetWindowPos(hWnd,0,10+width+10,10+height,width,height,SWP_NOOWNERZORDER);

  hWnd=GetDlgItem(parent,ID_SCHEMABROWSER_NAME_TEXT);
  SetWindowPos(hWnd,0,10+2*(width+10),10,width,height,SWP_NOOWNERZORDER);
  hWnd=GetDlgItem(parent,ID_SCHEMABROWSER_NAME);
  SetWindowPos(hWnd,0,10+2*(width+10),10+height,width,height,SWP_NOOWNERZORDER);

  hWnd=GetDlgItem(parent,ID_SCHEMABROWSER_CODE);
  SetWindowPos(hWnd,0,0,0,(rc.right-rc.left)-20,(rc.bottom-rc.top)-70,SWP_NOMOVE|SWP_NOOWNERZORDER);
}

void ShowSchemaObject(HWND hWnd)
{
  HWND schemalist,typelist,namelist,codewnd;
  char owner[40],type[40],name[40];
  int i;
  HCURSOR c;

  c=SetCursor(LoadCursor(NULL, IDC_WAIT));

  schemalist=GetDlgItem(hWnd,ID_SCHEMABROWSER_SCHEMA);
  i=SendMessage(schemalist,CB_GETCURSEL,(WPARAM)0,(LPARAM)0);
  SendMessage(schemalist,CB_GETLBTEXT,(WPARAM)i,(LPARAM)owner);

  typelist=GetDlgItem(hWnd,ID_SCHEMABROWSER_TYPE);
  i=SendMessage(typelist,CB_GETCURSEL,(WPARAM)0,(LPARAM)0);
  SendMessage(typelist,CB_GETLBTEXT,(WPARAM)i,(LPARAM)type);

  namelist=GetDlgItem(hWnd,ID_SCHEMABROWSER_NAME);
  i=SendMessage(namelist,CB_GETCURSEL,(WPARAM)0,(LPARAM)0);
  SendMessage(namelist,CB_GETLBTEXT,(WPARAM)i,(LPARAM)name);

  codewnd=GetDlgItem(hWnd,ID_SCHEMABROWSER_CODE);
  ShowWindow(codewnd,SW_HIDE);
  SetDlgItemText(hWnd,ID_SCHEMABROWSER_CODE,"");
  if (!strcmp(type,"TABLE"))
  {
    ProcessTable(hWnd,owner,name);
  }
  else if (!strcmp(type,"INDEX"))
  {
    ProcessIndex(hWnd,owner,name);
  }
  else if (!strcmp(type,"PROCEDURE"))
  {
    ProcessProcedure(hWnd,owner,name);
  }
  else if (!strcmp(type,"FUNCTION"))
  {
    ProcessFunction(hWnd,owner,name);
  }
  else if (!strcmp(type,"PACKAGE"))
  {
    ProcessPackage(hWnd,owner,name);
  }
  else if (!strcmp(type,"PACKAGE BODY"))
  {
    ProcessPackageBody(hWnd,owner,name);
  }
  else if (!strcmp(type,"TYPE"))
  {
    ProcessType(hWnd,owner,name);
  }
  else if (!strcmp(type,"TYPE BODY"))
  {
    ProcessTypeBody(hWnd,owner,name);
  }
  else if (!strcmp(type,"TRIGGER"))
  {
    ProcessTrigger(hWnd,owner,name);
  }
  else if (!strcmp(type,"VIEW"))
  {
    ProcessView(hWnd,owner,name);
  }
  else if (!strcmp(type,"JAVA SOURCE"))
  {
    ProcessJavaSource(hWnd,owner,name);
  }
  else if (!strcmp(type,"SYNONYM"))
  {
    ProcessSynonym(hWnd,owner,name);
  }
  else if (!strcmp(type,"SEQUENCE"))
  {
    ProcessSequence(hWnd,owner,name);
  }
  else
  {
    SchemaPrintf(hWnd,"Feature not implemented yet: %s",type);
  }
  SendMessage(codewnd,EM_SETSEL,(WPARAM)0,(LPARAM)0);
  SendMessage(codewnd,EM_SCROLLCARET,(WPARAM)0,(LPARAM)0);
  ShowWindow(codewnd,SW_SHOW);
  SetCursor(c);  
}



void FillNameList(HWND hWnd)
{
  HWND schemalist,typelist,namelist;
  char **bindvars;
  int i;
  HCURSOR c;

  c=SetCursor(LoadCursor(NULL, IDC_WAIT));
  bindvars=(char**)malloc(2*sizeof(char*));
  bindvars[0]=(char*)malloc(40*sizeof(char));
  bindvars[1]=(char*)malloc(40*sizeof(char));
  schemalist=GetDlgItem(hWnd,ID_SCHEMABROWSER_SCHEMA);
  i=SendMessage(schemalist,CB_GETCURSEL,(WPARAM)0,(LPARAM)0);
  SendMessage(schemalist,CB_GETLBTEXT,(WPARAM)i,(LPARAM)bindvars[0]);

  typelist=GetDlgItem(hWnd,ID_SCHEMABROWSER_TYPE);
  i=SendMessage(typelist,CB_GETCURSEL,(WPARAM)0,(LPARAM)0);
  SendMessage(typelist,CB_GETLBTEXT,(WPARAM)i,(LPARAM)bindvars[1]);

  namelist=GetDlgItem(hWnd,ID_SCHEMABROWSER_NAME);
  SendMessage(namelist,CB_RESETCONTENT,(WPARAM)0,(LPARAM)0);
  FillListBoxFromQuery(namelist,"select object_name from all_objects where owner=:1 and object_type=:2",bindvars,2,0);
  SendMessage(namelist,CB_SETCURSEL,(WPARAM)0,(LPARAM)0);

  free(bindvars[0]);
  free(bindvars[1]);
  free(bindvars);
  SetCursor(c);  
  ShowSchemaObject(hWnd);
}

void FillTypeList(HWND hWnd)
{
  HWND schemalist,typelist;
  char *owner;
  int i;
  HCURSOR c;

  c=SetCursor(LoadCursor(NULL, IDC_WAIT));
  owner=(char*)malloc(40*sizeof(char));

  schemalist=GetDlgItem(hWnd,ID_SCHEMABROWSER_SCHEMA);
  i=SendMessage(schemalist,CB_GETCURSEL,(WPARAM)0,(LPARAM)0);
  SendMessage(schemalist,CB_GETLBTEXT,(WPARAM)i,(LPARAM)owner);

  typelist=GetDlgItem(hWnd,ID_SCHEMABROWSER_TYPE);
  SendMessage(typelist,CB_RESETCONTENT,(WPARAM)0,(LPARAM)0);
  FillListBoxFromQuery(typelist,"select distinct object_type from all_objects where owner=:1 and object_type not in ('TABLE PARTITION','INDEX PARTITION')",(char**)&owner,1,0);
  SendMessage(typelist,CB_SETCURSEL,(WPARAM)0,(LPARAM)0);

  free(owner);

  FillNameList(hWnd);
  SetCursor(c);  
}

void FillSchemaList(HWND hWnd)
{
  HWND schemalist;
  int i;
  HCURSOR c;

  c=SetCursor(LoadCursor(NULL, IDC_WAIT));
  schemalist=GetDlgItem(hWnd,ID_SCHEMABROWSER_SCHEMA);
  SendMessage(schemalist,CB_RESETCONTENT,(WPARAM)0,(LPARAM)0);
  FillListBoxFromQuery(schemalist,"select username from (select username from all_users union select 'PUBLIC' from dual) u where exists (select 1 from all_objects where owner=u.username and rownum=1)",NULL,0,0);
  i=SendMessage(schemalist,CB_FINDSTRINGEXACT,(WPARAM)-1,(LPARAM)GetCurrentUser());
  SendMessage(schemalist,CB_SETCURSEL,(WPARAM)i,(LPARAM)0);
  FillTypeList(hWnd);
  SetCursor(c);  
}

LRESULT CALLBACK SchemaBrowserWndProc(HWND hWnd,
                                      UINT uMessage,
                                      WPARAM wParam,
                                      LPARAM lParam)
{
	switch (uMessage)
	{
		case WM_CREATE:
      CreateSchemaBrowser(hWnd);
      FillSchemaList(hWnd);
			return 0;

		case WM_SIZE:
  		ResizeSchemaBrowser(hWnd);
			return 1;
			break;

		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
        case ID_SCHEMABROWSER_SCHEMA:
          if (HIWORD(wParam)==CBN_SELCHANGE)
          {
            FillTypeList(hWnd);
          }
          break;
        case ID_SCHEMABROWSER_TYPE:
          if (HIWORD(wParam)==CBN_SELCHANGE)
          {
            FillNameList(hWnd);
          }
          break;
        case ID_SCHEMABROWSER_NAME:
          if (HIWORD(wParam)==CBN_SELCHANGE)
          {
            ShowSchemaObject(hWnd);
          }
          break;
        case IDA_SELECT_ALL:
          SendMessage(GetDlgItem(hWnd,ID_SCHEMABROWSER_CODE),EM_SETSEL,(WPARAM)0,(LPARAM)-1);
          break;
      }
			break;

		case WM_DESTROY:
			break;

    case WM_CLOSE:
      DeleteObject(sb_f);
      DeleteObject(sb_f2);
      DestroyWindow(hWnd);
      g_text->schema=NULL;
      break;

		default:
			break;
  }
	return DefWindowProc(hWnd, uMessage, wParam, lParam);
}

HWND ShowSchemaBrowser(HWND parent)
{
  HWND        hWnd;
	DWORD       dwStyle;
	BOOL        bSuccess = TRUE;
	WNDCLASSEX  wcex;
	ATOM        aReturn;
  static int  created=0;

  if (tid)
    return NULL;
  if (!created)
  {
	  wcex.cbSize          = sizeof(WNDCLASSEX);
	  wcex.style           = 0;
	  wcex.lpfnWndProc     = (WNDPROC)SchemaBrowserWndProc;
	  wcex.cbClsExtra      = 0;
	  wcex.cbWndExtra      = 0;
	  wcex.hInstance       = g_hInst;
	  wcex.hCursor         = LoadCursor(NULL, IDC_ARROW);
	  wcex.hbrBackground   = GetSysColorBrush(COLOR_3DFACE);
	  wcex.lpszMenuName    = NULL;
	  wcex.lpszClassName   = SCHEMA_BROWSER_CLASS_NAME;
	  wcex.hIcon           = LoadIcon(g_hInst, MAKEINTRESOURCE(IDI_JBSQL));
	  wcex.hIconSm         = LoadImage(g_hInst, MAKEINTRESOURCE(IDI_JBSQL), IMAGE_ICON, 16, 16, 0);

	  aReturn = RegisterClassEx(&wcex);
    if (aReturn==0)
      DisplayLastError(NULL);
    created=1;
  }

	dwStyle =   WS_POPUPWINDOW|WS_VISIBLE|WS_OVERLAPPEDWINDOW|WS_SIZEBOX;
	
	hWnd = CreateWindowEx( WS_EX_APPWINDOW|WS_EX_CONTROLPARENT|WS_EX_OVERLAPPEDWINDOW,          // ex style
												 SCHEMA_BROWSER_CLASS_NAME, // class name - defined in commctrl.h
												 "Schema Browser",          // dummy text
												 dwStyle,                   // style
												 0,                         // x position
												 0,                         // y position
												 500,                       // width
												 500,                       // height
												 parent,                    // parent
												 NULL,                      // ID
												 g_hInst,                   // instance
												 NULL);                     // no extra data
	if(!hWnd)
  {
    DisplayLastError(NULL);
	  return NULL;
  }
  ShowWindow(hWnd,SW_SHOW);

  return hWnd;
}

void SchemaPrintf(HWND hWnd,char *fmt,...)
{
  va_list param;
  char *str;
  int slen,x,lastx=0;

  va_start(param,fmt);
  str=myvsprintf(fmt,param);
  va_end(param);

  slen=strlen(str);
  for (x=0;x<(int)slen;x++)
  {
    switch (str[x])
    {
      case '\n':
        str[x]='\0';
        SendMessage(GetDlgItem(hWnd,ID_SCHEMABROWSER_CODE),EM_REPLACESEL,(WPARAM)FALSE,(LPARAM)&str[lastx]);
        SendMessage(GetDlgItem(hWnd,ID_SCHEMABROWSER_CODE),EM_REPLACESEL,(WPARAM)FALSE,(LPARAM)"\r\n");
        lastx=x+1;
        break;
      default:
        break;
    }
  }
  if (lastx<(int)slen)
  {
    SendMessage(GetDlgItem(hWnd,ID_SCHEMABROWSER_CODE),EM_REPLACESEL,(WPARAM)FALSE,(LPARAM)&str[lastx]);
  }

  free(str);
}
