#include "sql_analyze.h"

#define SQLSPLITTER_CLASS_NAME "SQLSplitterClass"

void FillIndexList(HWND tables,HWND listbox)
{
  int selection_count,*selected_items,x;
  char *table_name;

  selection_count=SendMessage(tables,LB_GETSELCOUNT,0,0);
  if (selection_count>0)
  {
    selected_items=(int*)malloc(selection_count*sizeof(int));
    SendMessage(tables,LB_GETSELITEMS,selection_count,(LPARAM)selected_items);
    for (x=0;x<selection_count;x++)
    {
      table_name=(char*)malloc(40*sizeof(char));
      SendMessage(tables,LB_GETTEXT,selected_items[x],(LPARAM)table_name);
      FillListBoxFromQuery(listbox,"select index_name from user_indexes where table_name=:table_name",(char**)&table_name,1,1);
      free(table_name);
    }
    free(selected_items);
  }
  else if (selection_count==LB_ERR)
  {
    x=SendMessage(tables,LB_GETCURSEL,0,0);
    if (x!=LB_ERR)
    {
      table_name=(char*)malloc(40*sizeof(char));
      SendMessage(tables,LB_GETTEXT,x,(LPARAM)table_name);
      FillListBoxFromQuery(listbox,"select index_name from user_indexes where table_name=:table_name",(char**)&table_name,1,1);
      free(table_name);
    }
  }
}

void FillHintLists(HWND hWnd)
{
  int selection,x;
  char hint[40];
  HWND tables;

  SendDlgItemMessage(hWnd,IDC_TABLES,LB_RESETCONTENT,0,0);
  SendDlgItemMessage(hWnd,IDC_INDEXES,LB_RESETCONTENT,0,0);
  SendDlgItemMessage(hWnd,IDC_TABLES2,LB_RESETCONTENT,0,0);
  SendDlgItemMessage(hWnd,IDC_INDEXES2,LB_RESETCONTENT,0,0);
  ShowWindow(GetDlgItem(hWnd,IDC_TABLES),SW_HIDE);
  ShowWindow(GetDlgItem(hWnd,IDC_INDEXES),SW_HIDE);
  ShowWindow(GetDlgItem(hWnd,IDC_TABLES2),SW_HIDE);
  ShowWindow(GetDlgItem(hWnd,IDC_INDEXES2),SW_HIDE);
  ShowWindow(GetDlgItem(hWnd,IDC_TABLE_TEXT),SW_HIDE);
  ShowWindow(GetDlgItem(hWnd,IDC_INDEX_TEXT),SW_HIDE);
  selection=SendDlgItemMessage(hWnd,IDC_HINTS,CB_GETCURSEL,0,0);
  if (selection!=CB_ERR)
  {
    SendDlgItemMessage(hWnd,IDC_HINTS,CB_GETLBTEXT,selection,(LPARAM)hint);
    for (x=0;x<nhints;x++)
    {
      if (!strcmp(hint,sqlhints[x].hint))
      {
        SetDlgItemText(GetDlgItem(hWnd,ID_SQLSPLITTER),IDC_HINT_TIP,sqlhints[x].description);
        if (sqlhints[x].table)
        {
          if (sqlhints[x].table==1)
          {
            tables=GetDlgItem(hWnd,IDC_TABLES);
            SetDlgItemText(hWnd,IDC_TABLE_TEXT,"Table:");
          }
          else
          {
            tables=GetDlgItem(hWnd,IDC_TABLES2);
            SetDlgItemText(hWnd,IDC_TABLE_TEXT,"Tables:");
          }
          ShowWindow(tables,SW_SHOW);
          ShowWindow(GetDlgItem(hWnd,IDC_TABLE_TEXT),SW_SHOW);
          FillListBoxFromQuery(tables,"select table_name from user_tables",NULL,0,1);
          if (sqlhints[x].index==1)
          {
            ShowWindow(GetDlgItem(hWnd,IDC_INDEX_TEXT),SW_SHOW);
            SetDlgItemText(hWnd,IDC_INDEX_TEXT,"Index:");
            ShowWindow(GetDlgItem(hWnd,IDC_INDEXES),SW_SHOW);
            FillIndexList(tables,GetDlgItem(hWnd,IDC_INDEXES));
          }
          else if (sqlhints[x].index>1)
          {
            ShowWindow(GetDlgItem(hWnd,IDC_INDEX_TEXT),SW_SHOW);
            SetDlgItemText(hWnd,IDC_INDEX_TEXT,"Indexes:");
            ShowWindow(GetDlgItem(hWnd,IDC_INDEXES2),SW_SHOW);
            FillIndexList(tables,GetDlgItem(hWnd,IDC_INDEXES2));
          }
        }
        break;
      }
    }
  }
}

void TableHintChanged(HWND hWnd)
{
  int selection,x;
  char hint[40];
  HWND tables;

  SendDlgItemMessage(hWnd,IDC_INDEXES,LB_RESETCONTENT,0,0);
  SendDlgItemMessage(hWnd,IDC_INDEXES2,LB_RESETCONTENT,0,0);
  selection=SendDlgItemMessage(hWnd,IDC_HINTS,CB_GETCURSEL,0,0);
  if (selection!=CB_ERR)
  {
    SendDlgItemMessage(hWnd,IDC_HINTS,CB_GETLBTEXT,selection,(LPARAM)hint);
    for (x=0;x<nhints;x++)
    {
      if (!strcmp(hint,sqlhints[x].hint))
      {
        if (sqlhints[x].table)
        {
          if (sqlhints[x].table==1)
          {
            tables=GetDlgItem(hWnd,IDC_TABLES);
          }
          else
          {
            tables=GetDlgItem(hWnd,IDC_TABLES2);
          }
          if (sqlhints[x].index==1)
          {
            FillIndexList(tables,GetDlgItem(hWnd,IDC_INDEXES));
          }
          else if (sqlhints[x].index>1)
          {
            FillIndexList(tables,GetDlgItem(hWnd,IDC_INDEXES2));
          }
        }
        break;
      }
    }
  }
}

char *ComposeHint(HWND hWnd)
{
  int selection,x,table_selection,index_selection,table_count,*selected_tables,index_count,*selected_indexes;
  char hint[40],table[40],index[40];
  static char new_hint[1000]="";

  new_hint[0]='\0';
  selection=SendDlgItemMessage(hWnd,IDC_HINTS,CB_GETCURSEL,0,0);
  if (selection!=CB_ERR)
  {
    SendDlgItemMessage(hWnd,IDC_HINTS,CB_GETLBTEXT,selection,(LPARAM)hint);
    for (x=0;x<nhints;x++)
    {
      if (!strcmp(hint,sqlhints[x].hint))
      {
        if (x==0)
          break;
        sprintf(new_hint,"/*+ %s",hint);
        if (sqlhints[x].table)
        {
          strcat(new_hint," (");
          if (sqlhints[x].table==1)
          {
            table_selection=SendDlgItemMessage(hWnd,IDC_TABLES,LB_GETCURSEL,0,0);
            if (table_selection!=LB_ERR)
            {
              SendDlgItemMessage(hWnd,IDC_TABLES,LB_GETTEXT,table_selection,(LPARAM)table);
              strcat(new_hint,table);
            }
          }
          else
          {
            table_count=SendDlgItemMessage(hWnd,IDC_TABLES2,LB_GETSELCOUNT,0,0);
            if (table_count>0)
            {
              selected_tables=(int*)malloc(table_count*sizeof(int));
              SendDlgItemMessage(hWnd,IDC_TABLES2,LB_GETSELITEMS,table_count,(LPARAM)selected_tables);
              for (x=0;x<table_count;x++)
              {
                SendDlgItemMessage(hWnd,IDC_TABLES2,LB_GETTEXT,selected_tables[x],(LPARAM)table);
                if (x>0)
                  strcat(new_hint," ");
                strcat(new_hint,table);
              }
              free(selected_tables);
            }
          }
          if (sqlhints[x].index==1)
          {
            index_selection=SendDlgItemMessage(hWnd,IDC_INDEXES,LB_GETCURSEL,0,0);
            if (index_selection!=LB_ERR)
            {
              SendDlgItemMessage(hWnd,IDC_INDEXES,LB_GETTEXT,index_selection,(LPARAM)index);
              strcat(new_hint,index);
            }
          }
          else if (sqlhints[x].index>1)
          {
            index_count=SendDlgItemMessage(hWnd,IDC_INDEXES2,LB_GETSELCOUNT,0,0);
            if (index_count>0)
            {
              selected_indexes=(int*)malloc(index_count*sizeof(int));
              SendDlgItemMessage(hWnd,IDC_INDEXES2,LB_GETSELITEMS,index_count,(LPARAM)selected_indexes);
              for (x=0;x<index_count;x++)
              {
                SendDlgItemMessage(hWnd,IDC_INDEXES2,LB_GETTEXT,selected_indexes[x],(LPARAM)index);
                strcat(new_hint," ");
                strcat(new_hint,index);
              }
              free(selected_indexes);
            }
          }
          strcat(new_hint,")");
        }
        strcat(new_hint," */");
        break;
      }
    }
  }
  return new_hint;
}

void DeleteCharacterFromString(char *str,int x)
{
  memmove(&str[x],&str[x+1],strlen(&str[x+1])+1);
}

void InsertStringIntoString(char *str,int x,char *chars)
{
  memmove(&str[x+strlen(chars)],&str[x],strlen(&str[x])+1);
  memcpy(&str[x],chars,strlen(chars));
}

void AddNewHint(HWND hWnd)
{
  char *new_hint,*sql_statement;
  int stmt_len,x;
  char tmp;

  new_hint=ComposeHint(hWnd);
  stmt_len=SendDlgItemMessage(hWnd,IDC_SQL_STATEMENT,WM_GETTEXTLENGTH,0,0);
  sql_statement=(char*)malloc(stmt_len+1000);
  GetDlgItemText(hWnd,IDC_SQL_STATEMENT,sql_statement,stmt_len+1);
  for (x=0;x<(int)strlen(sql_statement);x++)
  {
    if (strchr(" \t\n\r",sql_statement[x]))
    {
      tmp=sql_statement[x];
      sql_statement[x]='\0';
      if (!_stricmp(sql_statement,"select") ||
          !_stricmp(sql_statement,"update") ||
          !_stricmp(sql_statement,"delete"))
      {
        sql_statement[x]=tmp;
        x++;
        /* Find next non blank */
        while (x<(int)strlen(sql_statement) && strchr(" \t\n\r",sql_statement[x]))
          x++;
        if (!strncmp(&sql_statement[x],"/*+",3)) /* Hint is already there */
        {
          DeleteCharacterFromString(sql_statement,x);
          DeleteCharacterFromString(sql_statement,x);
          DeleteCharacterFromString(sql_statement,x);
          while (sql_statement[x] && strncmp(&sql_statement[x],"*/",2))
            DeleteCharacterFromString(sql_statement,x);
          if (!strncmp(&sql_statement[x],"*/",2))
          {
            DeleteCharacterFromString(sql_statement,x);
            DeleteCharacterFromString(sql_statement,x);
            if (strlen(new_hint)==0 && sql_statement[x]==' ')
              DeleteCharacterFromString(sql_statement,x);
          }
          InsertStringIntoString(sql_statement,x,new_hint);
        }
        else
        {
          if (strlen(new_hint)>0)
          {
            InsertStringIntoString(sql_statement,x,new_hint);
            InsertStringIntoString(sql_statement,x+strlen(new_hint)," ");
          }
        }
      }
      else
        sql_statement[x]=tmp;
      break;
    }
  }
  SetDlgItemText(hWnd,IDC_SQL_STATEMENT,sql_statement);
  free(sql_statement);
}

void ResizeSQLAnalyzer(HWND hWnd)
{
  RECT r,r2;
#define ITEM_DISTANCE 7
#define HINT_TIP_HEIGHT 70
#define PLAN_TREE_HEIGHT 150
#define BUTTON_HEIGHT 20
#define BUTTON_WIDTH 70
#define PROMPT_WIDTH 40
  int splitter_height;
  HWND shWnd;

  GetClientRect(hWnd,&r);
  shWnd=GetDlgItem(hWnd,ID_SQLSPLITTER);
  GetWindowRect(shWnd,&r2);
  splitter_height=r2.bottom-r2.top;
  SetWindowPos(GetDlgItem(shWnd,IDC_HINT_TIP),
               NULL,
               10+window_h_offset,
               (r2.bottom-r2.top)-HINT_TIP_HEIGHT-window_v_offset-5,
               (r.right-r.left)-20,
               HINT_TIP_HEIGHT-5-window_v_offset,
               SWP_NOACTIVATE|SWP_NOZORDER);
  SetWindowPos(GetDlgItem(shWnd,IDC_PLAN_TREE),
               NULL,
               10+window_h_offset,
               5,
               (r.right-r.left)-20,
               splitter_height-HINT_TIP_HEIGHT-ITEM_DISTANCE-10-window_v_offset,
               SWP_NOACTIVATE|SWP_NOZORDER);
  SetWindowPos(GetDlgItem(hWnd,IDC_EXECUTE),
               NULL,
               10,
               r.bottom-splitter_height-BUTTON_HEIGHT-ITEM_DISTANCE*1,
               BUTTON_WIDTH,
               BUTTON_HEIGHT,
               SWP_NOACTIVATE|SWP_NOZORDER);
  SetWindowPos(GetDlgItem(hWnd,IDC_CLOSE),
               NULL,
               10+BUTTON_WIDTH+ITEM_DISTANCE,
               r.bottom-splitter_height-BUTTON_HEIGHT-ITEM_DISTANCE*1,
               BUTTON_WIDTH,
               BUTTON_HEIGHT,
               SWP_NOACTIVATE|SWP_NOZORDER);
  SetWindowPos(GetDlgItem(hWnd,IDC_EXPLAIN_PLAN),
               NULL,
               10,
               r.bottom-splitter_height-2*BUTTON_HEIGHT-ITEM_DISTANCE*2,
               BUTTON_WIDTH,
               BUTTON_HEIGHT,
               SWP_NOACTIVATE|SWP_NOZORDER);
  SetWindowPos(GetDlgItem(hWnd,IDC_HINT_TEXT),
               NULL,
               10,
               r.bottom-splitter_height-3*BUTTON_HEIGHT-ITEM_DISTANCE*3+2,
               PROMPT_WIDTH-20,
               BUTTON_HEIGHT,
               SWP_NOACTIVATE|SWP_NOZORDER);
  SetWindowPos(GetDlgItem(hWnd,IDC_HINTS),
               NULL,
               10+PROMPT_WIDTH-10,
               r.bottom-splitter_height-3*BUTTON_HEIGHT-ITEM_DISTANCE*3,
               (r.right-r.left-20)/3-PROMPT_WIDTH+10-ITEM_DISTANCE,
               BUTTON_HEIGHT,
               SWP_NOACTIVATE|SWP_NOZORDER);
  SetWindowPos(GetDlgItem(hWnd,IDC_TABLE_TEXT),
               NULL,
               10+(r.right-r.left-20)/3,
               r.bottom-splitter_height-3*BUTTON_HEIGHT-ITEM_DISTANCE*3+2,
               PROMPT_WIDTH,
               BUTTON_HEIGHT,
               SWP_NOACTIVATE|SWP_NOZORDER);
  SetWindowPos(GetDlgItem(hWnd,IDC_TABLES),
               NULL,
               10+(r.right-r.left-20)/3+PROMPT_WIDTH,
               r.bottom-splitter_height-3*BUTTON_HEIGHT-ITEM_DISTANCE*3,
               (r.right-r.left-20)/3-PROMPT_WIDTH-ITEM_DISTANCE,
               3*BUTTON_HEIGHT+2*ITEM_DISTANCE,
               SWP_NOACTIVATE|SWP_NOZORDER);
  SetWindowPos(GetDlgItem(hWnd,IDC_TABLES2),
               NULL,
               10+(r.right-r.left-20)/3+PROMPT_WIDTH,
               r.bottom-splitter_height-3*BUTTON_HEIGHT-ITEM_DISTANCE*3,
               (r.right-r.left-20)/3-PROMPT_WIDTH-ITEM_DISTANCE,
               3*BUTTON_HEIGHT+2*ITEM_DISTANCE,
               SWP_NOACTIVATE|SWP_NOZORDER);
  SetWindowPos(GetDlgItem(hWnd,IDC_INDEX_TEXT),
               NULL,
               10+2*((r.right-r.left-20)/3),
               r.bottom-splitter_height-3*BUTTON_HEIGHT-ITEM_DISTANCE*3+2,
               PROMPT_WIDTH,
               BUTTON_HEIGHT,
               SWP_NOACTIVATE|SWP_NOZORDER);
  SetWindowPos(GetDlgItem(hWnd,IDC_INDEXES),
               NULL,
               10+2*((r.right-r.left-20)/3)+PROMPT_WIDTH,
               r.bottom-splitter_height-3*BUTTON_HEIGHT-ITEM_DISTANCE*3,
               (r.right-r.left-20)/3-PROMPT_WIDTH,
               3*BUTTON_HEIGHT+2*ITEM_DISTANCE,
               SWP_NOACTIVATE|SWP_NOZORDER);
  SetWindowPos(GetDlgItem(hWnd,IDC_INDEXES2),
               NULL,
               10+2*((r.right-r.left-20)/3)+PROMPT_WIDTH,
               r.bottom-splitter_height-3*BUTTON_HEIGHT-ITEM_DISTANCE*3,
               (r.right-r.left-20)/3-PROMPT_WIDTH,
               3*BUTTON_HEIGHT+2*ITEM_DISTANCE,
               SWP_NOACTIVATE|SWP_NOZORDER);
  SetWindowPos(GetDlgItem(hWnd,IDC_SQL_STATEMENT),
               NULL,
               10,
               10,
               (r.right-r.left)-20,
               r.bottom-(splitter_height+4*BUTTON_HEIGHT+ITEM_DISTANCE*3),
               SWP_NOACTIVATE|SWP_NOZORDER);
  SetWindowPos(shWnd,
               NULL,
							 -2*window_h_offset,
							 r.bottom-splitter_height+2*window_v_offset,
							 r.right-r.left+4*window_h_offset,
							 splitter_height,
               SWP_NOACTIVATE|SWP_NOZORDER);
  InvalidateRect(hWnd,&r,TRUE);
}

LRESULT CALLBACK SQLSplitterWndProc(HWND hWnd,
                                    UINT uMessage,
                                    WPARAM wParam,
                                    LPARAM lParam)
{
	switch (uMessage)
	{
		case WM_SIZE:
      SendMessage(GetParent(hWnd),WM_SIZE,0,0);
			break;
    
		case WM_NCHITTEST:
			{
				LRESULT ret;

				ret=DefWindowProc(hWnd, uMessage, wParam, lParam);
				switch (ret)
				{
					case HTBORDER:
						return HTTOP;
				  case HTTOPLEFT:
            return HTTOP;
					case HTTOPRIGHT:
						return HTTOP;
					case HTBOTTOMRIGHT:
					case HTBOTTOMLEFT:
					case HTBOTTOM:
					case HTGROWBOX:
					case HTLEFT:
					case HTRIGHT:
						return HTBORDER;
					default:
						return ret;
				}
			}
			break;
		default:
			break;
	}
	return DefWindowProc(hWnd, uMessage, wParam, lParam);
}

HWND CreateSQLSplitter(HINSTANCE hInstance, HWND hwndParent)
{
	DWORD       dwStyle;
	HWND        hwndSplitter;
	BOOL        bSuccess = TRUE;
	WNDCLASSEX  wcex;
	ATOM        aReturn;
  RECT        r;

	wcex.cbSize          = sizeof(WNDCLASSEX);
	wcex.style           = 0;
  wcex.lpfnWndProc     = (WNDPROC)SQLSplitterWndProc;
	wcex.cbClsExtra      = 0;
	wcex.cbWndExtra      = 0;
	wcex.hInstance       = hInstance;
	wcex.hCursor         = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground   = NULL;
	wcex.lpszMenuName    = NULL;
	wcex.lpszClassName   = SQLSPLITTER_CLASS_NAME;
	wcex.hIcon           = NULL;
	wcex.hIconSm         = NULL;

	aReturn = RegisterClassEx(&wcex);

	dwStyle =   WS_CHILD | 
							WS_VISIBLE |
							WS_DLGFRAME;
	
  GetWindowRect(hwndParent,&r);
	hwndSplitter = CreateWindowEx(   WS_EX_OVERLAPPEDWINDOW,          // ex style
																	 SQLSPLITTER_CLASS_NAME,    // class name
																	 "",                        // dummy text
																	 dwStyle,                   // style
																	 0,                         // x position
																	 r.bottom-(HINT_TIP_HEIGHT+PLAN_TREE_HEIGHT+30+3*ITEM_DISTANCE),// y position
																	 r.right-r.left,            // width
																	 HINT_TIP_HEIGHT+PLAN_TREE_HEIGHT+30+3*ITEM_DISTANCE, // height
																	 hwndParent,                // parent
																	 (HMENU)ID_SQLSPLITTER,     // ID
																	 g_hInst,                   // instance
																	 NULL);                     // no extra data
	if(!hwndSplitter)
	  return NULL;

  return hwndSplitter;
}

LRESULT CALLBACK AnalyzeProc( HWND hWnd,
                              UINT uMessage,
                              WPARAM wParam,
                              LPARAM lParam)
{
	switch (uMessage)
	{
    case WM_INITDIALOG:
    {
      HFONT f;
      HDC hDC;
      int x;
      HWND shWnd,h;

      SetFocus(hWnd);
      hDC=GetDC(hWnd);
      f=CreateFont(-MulDiv(10, GetDeviceCaps(hDC, LOGPIXELSY), 72), // logical height of font
                   0,                     // logical average character width
                   0,                     // angle of escapement
                   0,                     // base-line orientation angle
                   FW_NORMAL,             // font weight
                   FALSE,                 // italic attribute flag
                   FALSE,                 // underline attribute flag
                   FALSE,                 // strikeout attribute flag
                   DEFAULT_CHARSET,       // character set identifier
                   OUT_DEFAULT_PRECIS,    // output precision
                   CLIP_DEFAULT_PRECIS,   // clipping precision
                   DEFAULT_QUALITY,       // output quality
                   FF_MODERN,             // pitch and family
                   "Courier New"          // pointer to typeface name string
                   );

      SendMessage(GetDlgItem(hWnd,IDC_SQL_STATEMENT),WM_SETFONT,(WPARAM)f,(LPARAM)TRUE);
      ReleaseDC(hWnd,hDC);
      for (x=0;x<nhints;x++)
      {
        SendDlgItemMessage(hWnd,IDC_HINTS,CB_ADDSTRING,0,(LPARAM)sqlhints[x].hint);
      }
      SendDlgItemMessage(hWnd,IDC_HINTS,CB_SETCURSEL,SendDlgItemMessage(hWnd,IDC_HINTS,CB_FINDSTRING,-1,(LPARAM)"None"),0);
      FillHintLists(hWnd);
      shWnd=CreateSQLSplitter(g_hInst,hWnd);
      h=CreateWindowEx(WS_EX_WINDOWEDGE,          // ex style
									   WC_TREEVIEW,             // class name
									   "",                        // dummy text
									   WS_CHILD | WS_VISIBLE | TVS_HASLINES | TVS_HASBUTTONS,     // style
									   10,                        // x position
									   1,                         // y position
									   100,                       // width
									   PLAN_TREE_HEIGHT,          // height
									   shWnd,                     // parent
									   (HMENU)IDC_PLAN_TREE,      // ID
									   g_hInst,                   // instance
									   NULL);                     // no extra data
      h=CreateWindowEx(WS_EX_WINDOWEDGE,          // ex style
									   "STATIC",                    // class name
									   "",                        // dummy text
									   WS_CHILD | WS_VISIBLE | SS_LEFT | SS_SUNKEN,     // style
									   10,                        // x position
									   1,                         // y position
									   100,                       // width
									   HINT_TIP_HEIGHT,           // height
									   shWnd,                     // parent
									   (HMENU)IDC_HINT_TIP,       // ID
									   g_hInst,                   // instance
									   NULL);                     // no extra data
      SendMessage(h,WM_SETFONT,SendMessage(GetDlgItem(hWnd,IDC_HINT_TEXT),WM_GETFONT,(WPARAM)0,(LPARAM)0),(LPARAM)0);

      ResizeSQLAnalyzer(hWnd);
      break;
    }
		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case IDC_EXPLAIN_PLAN:
        {
          int len;
          char *str;

          if (tid)
            return TRUE;
          len=SendMessage(GetDlgItem(hWnd,IDC_SQL_STATEMENT),WM_GETTEXTLENGTH,0,0);
          if (len)
          {
            str=(char*)malloc(len+1);
            GetDlgItemText(hWnd,IDC_SQL_STATEMENT,str,len+1);
            ExplainPlan(hWnd,str);
            free(str);
          }
          return TRUE;
        }
        case IDC_EXECUTE:
        {
          int len,slen,x,lastx=0;
          char *str;

          if (tid)
            return TRUE;
          len=SendMessage(GetDlgItem(hWnd,IDC_SQL_STATEMENT),WM_GETTEXTLENGTH,0,0);
          if (len)
          {
            str=(char*)malloc(len+2);
            GetDlgItemText(hWnd,IDC_SQL_STATEMENT,str,len+2);
            Trim(str);
            if (str[strlen(str)-1]!=';')
              strcat(str,";");
            g_text->no_process=1;
            slen=strlen(str);
            for (x=0;x<(int)slen;x++)
            {
              switch (str[x])
              {
                case '\r':
                  str[x]='\0';
                  InsertUnparsedLineBuffer(g_text,&str[lastx]);
                  InsertNewLineBuffer(g_text);
                  lastx=x+2;
                  break;
                default:
                  break;
              }
            }
            if (lastx<slen)
              InsertUnparsedLineBuffer(g_text,&str[lastx]);
            g_text->no_process=0;
            InsertNewLineBuffer(g_text);
            free(str);
          }
          return TRUE;
        }
				case IDC_CLOSE:
					EndDialog(hWnd,FALSE);
          g_text->analyze=NULL;
					return TRUE;
        case IDC_HINTS:
          if (tid)
            return TRUE;
          if (HIWORD(wParam)==CBN_SELCHANGE)
          {
            FillHintLists(hWnd);
            AddNewHint(hWnd);
          }
          break;
        case IDC_TABLES:
          if (tid)
            return TRUE;
          if (HIWORD(wParam)==CBN_SELCHANGE)
          {
            TableHintChanged(hWnd);
            AddNewHint(hWnd);
          }
          break;
        case IDC_TABLES2:
          if (tid)
            return TRUE;
          if (HIWORD(wParam)==CBN_SELCHANGE)
          {
            TableHintChanged(hWnd);
            AddNewHint(hWnd);
          }
          break;
        case IDC_INDEXES:
          if (tid)
            return TRUE;
          if (HIWORD(wParam)==CBN_SELCHANGE)
            AddNewHint(hWnd);
          break;
        case IDC_INDEXES2:
          if (tid)
            return TRUE;
          if (HIWORD(wParam)==CBN_SELCHANGE)
            AddNewHint(hWnd);
          break;
			}
			break;

    case WM_CLOSE:
			EndDialog(hWnd,FALSE);
      g_text->analyze=NULL;
      return TRUE;

    case WM_SIZE:
      ResizeSQLAnalyzer(hWnd);
      break;
		default:
			break;
	}
  return FALSE;
}



HWND ShowSqlAnalyzer(HWND parenthWnd)
{
	FARPROC analyzeproc;
  HWND w;

	analyzeproc=MakeProcInstance((FARPROC)AnalyzeProc,hInst);
	w=CreateDialogParam(hInst,MAKEINTRESOURCE(IDD_ANALYZE),parenthWnd,(DLGPROC)analyzeproc,0);
  ShowWindow(w,SW_SHOW);
	FreeProcInstance(analyzeproc);

  return w;
}

void SetAnalyzerText(TextWidget *text,char *sqlstmt)
{
  char *str=NULL;
  int slen,lastx=0,x,slen2;

  slen=strlen(sqlstmt);
  str=strdup("");
  for (x=0;x<(int)slen;x++)
  {
    switch (sqlstmt[x])
    {
      case '\n':
        slen2=strlen(str);
        str=realloc(str,slen2+x-lastx+3);
        memcpy(&str[slen2],&sqlstmt[lastx],x-lastx);
        str[slen2+x-lastx]='\r';
        str[slen2+x-lastx+1]='\n';
        str[slen2+x-lastx+2]='\0';
        lastx=x+1;
        break;
      default:
        break;
    }
  }
  if (lastx<(int)slen)
  {
    slen2=strlen(str);
    str=realloc(str,slen2+x-lastx+1);
    memcpy(&str[slen2],&sqlstmt[lastx],x-lastx);
    str[slen2+x-lastx]='\0';
  }
  SetDlgItemText(text->analyze,IDC_SQL_STATEMENT,str);
  free(str);
}


void ShowAutotrace(ExecuteStruct *s)
{
  if (s->INT_OPTION(AUTOTRACE))
  {
    if (s->text->analyze==NULL)
      s->text->analyze=ShowSqlAnalyzer(NULL);
    SetAnalyzerText(s->text,s->data);
    ExplainPlan(s->text->analyze,s->data);
  }
}

void AnalyzeError(char *fmt,...)
{
  va_list param;
  char *str;
  TVINSERTSTRUCT item_data;
  HTREEITEM tree_item;

  va_start(param,fmt);
  str=myvsprintf(fmt,param);
  va_end(param);

  TreeView_DeleteAllItems(GetDlgItem(GetDlgItem(g_text->analyze,ID_SQLSPLITTER),IDC_PLAN_TREE));

  item_data.hParent=TVI_ROOT;
  item_data.hInsertAfter=TVI_LAST;
  item_data.item.mask=TVIF_STATE|TVIF_TEXT;
  item_data.item.state=TVIS_EXPANDED;
  item_data.item.stateMask=TVIS_EXPANDED;
  item_data.item.pszText=str;
  item_data.item.cchTextMax=strlen(str);

  tree_item=TreeView_InsertItem(GetDlgItem(GetDlgItem(g_text->analyze,ID_SQLSPLITTER),IDC_PLAN_TREE),&item_data);
  free(str);
}
